package org.biospice.moma;
import com.sri.oaa2.com.LibCom;
import com.sri.oaa2.com.LibComTcpProtocol;
import com.sri.oaa2.icl.IclList;
import com.sri.oaa2.icl.IclStruct;
import com.sri.oaa2.icl.IclTerm;
import com.sri.oaa2.icl.IclUtils;
import com.sri.oaa2.lib.LibOaa;
import com.sri.oaa2.lib.OAAEventListener;


/**
 * A utility class to register the moma service with the facilitator.
 *
 * @author <a href="mailto:">Peter Kharchenko</a>
 * @version 1.0
 */
public class StartMomaService {

    public static void main(String[] args) {
        LibOaa myOaa = new LibOaa(new LibCom(new LibComTcpProtocol(), null));
        
        if (!myOaa.getComLib().comConnect("parent",
                                          IclUtils.icl("tcp(Host,Port)"),
                                          (IclList) IclUtils.icl("[]"))) {
            System.out.println("Couldn't connect to facilitator");
            return;
        }
        try {
            myOaa.oaaRegisterCallback("oaa_AppDoEvent",new MomaService());


            if (!myOaa.oaaRegister("parent",
                                   "moma",
                                   IclUtils.icl("[moma(MutateIsozymes,UptakeRates,MutatedGenes,WTFluxes,LPFluxes,QPFluxes),moma_gene_names(GeneNames,GrowthFluxNumber),moma_mutable_genes(GeneNumbers,PrettyGeneNames)]"),
                                   (IclList) IclUtils.icl("[]"))) {
                System.out.println("Could not register");
                return;
            }

            myOaa.oaaReady(true);
            System.out.println("moma service started");
        } catch (Exception e) {
            System.err.println("unable to start moma service "+e);
            e.printStackTrace();
            myOaa.oaaReady(false);
        }
    }
}
